<template>
  <div class="select page" :style="{'backgroundImage': 'url('+bgImg+')'}">
      <div class="page-wrapper">
        <img :src="this.$logoimg" width="110"/>
        <div class="space-lg"/>
        <h1 class="font-size-title">{{user.userName}}，您好！</h1>
        <div class="space-sm"/>
        <p class="font-size-subheading">请选择轩尼诗特调</p>
        <div class="space-md"/>
        <!-- START loop of drinks -->
        <div class="drinks-wrapper">
          <div class="drinks">
            <swiper :options="swiperOption" ref="selectSwiper">
              <!-- slides -->
              <swiper-slide v-for="(drink,index) in filteredDrinks" :key="index">
                <div class="drink" :class="{disabled: isItemDisable(drink.type)}" >
                  <a :data-index="index" class="drink__link">
                    <img class="drink__image" :src="drink.image" />
                  </a>
                </div>
              </swiper-slide>
            </swiper>
          </div>
        </div>
        <!-- END loop of drinks -->
      </div>
      <router-link to="/"  class="btn-leave">
        <img :src="closeImg" />
      </router-link>

      <!-- popup drink details -->
      <modal
        v-show="isShowingModal"
        :count="this.count"
        :index="this.activeModal"
        @close="closeModal"
      />
  </div>
</template>



<script>
import modal from '../modal.vue';
import 'swiper/dist/css/swiper.css'
import JQuery from 'jquery'

export default {
  name: 'Select-shanghai',
  components: {
    modal,
  },
  data () {
    return {
      closeImg: require("../../assets/ui-cross.png"),
      bgImg: require("../../assets/bg_dim.jpg"),
      user: this.$config.user,
      isShowingModal: false,
      activeModal: null,
      drinks: this.$config.drinks[this.$config.venue],
      filteredDrinks: this.getValidDrinks(),
      //drinks: [],
      swiperOption: {
        slidesPerView: 'auto',
        centeredSlides: true,
        spaceBetween: 30,
        loop: true,
      },
      count: 0,
    }
  },
  methods: {
    getValidDrinks: function(){
      var vm = this;
      var allDrinks = this.$config.drinks[this.$config.venue];
      var filterDrinks = allDrinks.filter( drink => vm.getToday() >= drink.startDate && vm.getToday() <= drink.endDate );
      return filterDrinks;
    },
    isItemDisable: function(type){
      //console.log('type:', type)
      //console.log("this.$config.user.eventquota['icecream']", this.$config.user.eventquota['icecream']);
      if( type == 'icecream1' ){
        if( this.$config.user.eventquota['icecream1'] <= 0 ){
          return true
        }else{
          return false
        }
      }else if( type == 'icecream2' ){
        if( this.$config.user.eventquota['icecream2'] <= 0 ){
          return true
        }else{
          return false
        }
      }else if( type == 'milkshake' ){
        if( this.$config.user.eventquota['milkshake'] <= 0 ){
          return true
        }else{
          return false
        }
      }else{
        return false;
      }
    },
    getToday() {
      var num;

      function toTwoDigit(myNumber){
        return ("0" + myNumber).slice(-2);
      }

      var yyyy = new Date().getFullYear();
      var mm = toTwoDigit(new Date().getMonth() + 1);
      var dd = toTwoDigit(new Date().getDate());

      var fulldate = yyyy.toString() + mm.toString() + dd.toString();
      num = parseInt(fulldate);

      return num;
    },
    showModal(index) {
      this.isShowingModal = true;
      this.activeModal = index;
      this.count ++
    },
    closeModal() {
      this.isShowingModal = false;
      this.activeModal = null;
    },
    evt() {
      var vm = this;
      JQuery("#app").on('click', '.drink__link', function(e){
        e.preventDefault();
        var index = JQuery(this).attr('data-index');
        vm.showModal(parseInt(index));
      })
    },
    unbindEvt() {
      JQuery("#app").off('click', '.drink__link')
    },
    setDrinks(){
      var vm = this;
      //vm.drinks = this.$config.drinks[this.$config.venue];
      setTimeout(function(){
          if(typeof(vm.$refs.selectSwiper) == "object"){
            vm.$refs.selectSwiper.swiper.update();
            vm.$refs.selectSwiper.swiper.slideTo(3);	
          }
      },200)
    },
    checkValid(){
      if(this.$config.user == "" || this.$config.venue == "" ){
        this.$router.push({ 
          path: '/',
        })
      }
    }
    
  },
  mounted: function(){
    this.checkValid();
    this.evt() 
    this.setDrinks();
  },
  beforeDestroy: function(){
    this.unbindEvt()
  }
  
}
</script>

<style scoped lang="sass">
@import "../../styles/pages/select.sass"
</style>
